<html>
<head>
<title>OgreGLTexture.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_5bc5f2f46c6364f2594540d45df3d051.html">GL</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7b8a29f58b064e3a63f570f2fc89729.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreGLTexture.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreGLTexture_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __GLTEXTURE_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __GLTEXTURE_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLPrerequisites_8h.html">OgreGLPrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlatform_8h.html">OgrePlatform.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderTexture_8h.html">OgreRenderTexture.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreTexture_8h.html">OgreTexture.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreGLSupport_8h.html">OgreGLSupport.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwarePixelBuffer_8h.html">OgreHardwarePixelBuffer.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classOgre_1_1GLTexture.html">00041</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1Texture.html" title="Abstract class representing a Texture resource.">Texture</a>
<a name="l00042"></a>00042     {
<a name="l00043"></a>00043     <span class="keyword">public</span>:
<a name="l00044"></a>00044         <span class="comment">// Constructor</span>
<a name="l00045"></a>00045         <a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a>(<a class="code" href="classOgre_1_1ResourceManager.html" title="Defines a generic resource handler.">ResourceManager</a>* creator, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <a class="code" href="namespaceOgre.html#aeb9f62c8e6c4239315286c63321722b2">ResourceHandle</a> handle,
<a name="l00046"></a>00046             <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; group, <span class="keywordtype">bool</span> isManual, <a class="code" href="classOgre_1_1ManualResourceLoader.html" title="Interface describing a manual resource loader.">ManualResourceLoader</a>* loader, 
<a name="l00047"></a>00047             <a class="code" href="classOgre_1_1GLSupport.html">GLSupport</a>&amp; support);
<a name="l00048"></a>00048 
<a name="l00049"></a>00049         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a>();      
<a name="l00050"></a>00050 
<a name="l00051"></a>00051         <span class="keywordtype">void</span> createRenderTexture();
<a name="l00052"></a>00052             
<a name="l00054"></a>00054         <a class="code" href="classOgre_1_1HardwarePixelBufferSharedPtr.html" title="Shared pointer implementation used to share pixel buffers.">HardwarePixelBufferSharedPtr</a> getBuffer(<span class="keywordtype">size_t</span> face, <span class="keywordtype">size_t</span> mipmap);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056         <span class="comment">// Takes the OGRE texture type (1d/2d/3d/cube) and returns the appropriate GL one</span>
<a name="l00057"></a>00057         GLenum getGLTextureTarget(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classOgre_1_1GLTexture.html#ad21b598246916df2d91a2931e0ba6b5b">00059</a>         GLuint getGLID()<span class="keyword"> const</span>
<a name="l00060"></a>00060 <span class="keyword">        </span>{
<a name="l00061"></a>00061             <span class="keywordflow">return</span> mTextureID;
<a name="l00062"></a>00062         }
<a name="l00063"></a>00063         
<a name="l00064"></a>00064         <span class="keywordtype">void</span> getCustomAttribute(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keywordtype">void</span>* pData);
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     <span class="keyword">protected</span>:
<a name="l00068"></a>00068         <span class="keywordtype">void</span> createInternalResourcesImpl(<span class="keywordtype">void</span>);
<a name="l00070"></a>00070         <span class="keywordtype">void</span> prepareImpl(<span class="keywordtype">void</span>);
<a name="l00072"></a>00072         <span class="keywordtype">void</span> unprepareImpl(<span class="keywordtype">void</span>);
<a name="l00074"></a>00074         <span class="keywordtype">void</span> loadImpl(<span class="keywordtype">void</span>);
<a name="l00076"></a>00076         <span class="keywordtype">void</span> freeInternalResourcesImpl(<span class="keywordtype">void</span>);
<a name="l00077"></a>00077 
<a name="l00083"></a>00083         <span class="keywordtype">void</span> _createSurfaceList();
<a name="l00084"></a>00084 
<a name="l00086"></a><a class="code" href="classOgre_1_1GLTexture.html#a208487678a5486dc1ca1e1149380b132">00086</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr&lt;vector&lt;Image&gt;::type</a> &gt; <a class="code" href="classOgre_1_1GLTexture.html#a208487678a5486dc1ca1e1149380b132" title="Used to hold images between calls to prepare and load.">LoadedImages</a>;
<a name="l00087"></a>00087 
<a name="l00092"></a><a class="code" href="classOgre_1_1GLTexture.html#adc7751feca372542f06343f3df71214b">00092</a>         <a class="code" href="classOgre_1_1SharedPtr.html">LoadedImages</a> <a class="code" href="classOgre_1_1GLTexture.html#adc7751feca372542f06343f3df71214b" title="Vector of images that were pulled from disk by prepareLoad but have yet to be pushed into texture mem...">mLoadedImages</a>;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095     <span class="keyword">private</span>:
<a name="l00096"></a><a class="code" href="classOgre_1_1GLTexture.html#a56ba7fbb3eaca1a816148519422d3912">00096</a>         GLuint <a class="code" href="classOgre_1_1GLTexture.html#a56ba7fbb3eaca1a816148519422d3912">mTextureID</a>;
<a name="l00097"></a><a class="code" href="classOgre_1_1GLTexture.html#aaff77c9210ad70cd3cb613f7bd8c1c38">00097</a>         <a class="code" href="classOgre_1_1GLSupport.html">GLSupport</a>&amp; <a class="code" href="classOgre_1_1GLTexture.html#aaff77c9210ad70cd3cb613f7bd8c1c38">mGLSupport</a>;
<a name="l00098"></a>00098         
<a name="l00100"></a><a class="code" href="classOgre_1_1GLTexture.html#ad53c0278d43b125df9485ea0695b81b5">00100</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html">vector&lt;HardwarePixelBufferSharedPtr&gt;::type</a> <a class="code" href="classOgre_1_1GLTexture.html#ad53c0278d43b125df9485ea0695b81b5" title="Vector of pointers to subsurfaces.">SurfaceList</a>;
<a name="l00101"></a><a class="code" href="classOgre_1_1GLTexture.html#ab378ae6edb83104d50ed55642fd8ea3c">00101</a>         <a class="code" href="classOgre_1_1GLTexture.html#ad53c0278d43b125df9485ea0695b81b5" title="Vector of pointers to subsurfaces.">SurfaceList</a> <a class="code" href="classOgre_1_1GLTexture.html#ab378ae6edb83104d50ed55642fd8ea3c">mSurfaceList</a>;
<a name="l00102"></a>00102     };
<a name="l00103"></a>00103 
<a name="l00110"></a><a class="code" href="classOgre_1_1GLTexturePtr.html">00110</a>     <span class="keyword">class </span><a class="code" href="OgreGLPrerequisites_8h.html#a84aebcce92aa9d20cdb06ab0eab6b1f8" title="Lots of generated code in here which triggers the new VC CRT security warnings.">_OgreGLExport</a> <a class="code" href="classOgre_1_1GLTexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GLTexturePtr.">GLTexturePtr</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;GLTexture&gt; 
<a name="l00111"></a>00111     {
<a name="l00112"></a>00112     <span class="keyword">public</span>:
<a name="l00113"></a><a class="code" href="classOgre_1_1GLTexturePtr.html#adabe928697f3da8f5df7cafd2f3439d0">00113</a>         <a class="code" href="classOgre_1_1GLTexturePtr.html#adabe928697f3da8f5df7cafd2f3439d0">GLTexturePtr</a>() : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a>&gt;() {}
<a name="l00114"></a><a class="code" href="classOgre_1_1GLTexturePtr.html#a5f40b6f1757774f6cfc7c6e349068f11">00114</a>         <span class="keyword">explicit</span> <a class="code" href="classOgre_1_1GLTexturePtr.html#a5f40b6f1757774f6cfc7c6e349068f11">GLTexturePtr</a>(<a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a>* rep) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a>&gt;(rep) {}
<a name="l00115"></a><a class="code" href="classOgre_1_1GLTexturePtr.html#a634a1c0c41187f0b8c166d78b21e8472">00115</a>         <a class="code" href="classOgre_1_1GLTexturePtr.html#a634a1c0c41187f0b8c166d78b21e8472">GLTexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1GLTexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GLTexturePtr.">GLTexturePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a>&gt;(r) {} 
<a name="l00116"></a><a class="code" href="classOgre_1_1GLTexturePtr.html#af947528ee47b0cb1e86281e55c216e39">00116</a>         <a class="code" href="classOgre_1_1GLTexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GLTexturePtr.">GLTexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a>&gt;()
<a name="l00117"></a>00117         {
<a name="l00118"></a>00118             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00119"></a>00119             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00120"></a>00120             {
<a name="l00121"></a>00121                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00122"></a>00122                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00123"></a>00123                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00124"></a>00124                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00125"></a>00125                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00126"></a>00126                 {
<a name="l00127"></a>00127                     ++(*pUseCount);
<a name="l00128"></a>00128                 }
<a name="l00129"></a>00129             }
<a name="l00130"></a>00130         }
<a name="l00131"></a><a class="code" href="classOgre_1_1GLTexturePtr.html#aebc5cf35e7659625352668975ee0c78c">00131</a>         <a class="code" href="classOgre_1_1GLTexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GLTexturePtr.">GLTexturePtr</a>(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; r) : <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">SharedPtr</a>&lt;<a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a>&gt;()
<a name="l00132"></a>00132         {
<a name="l00133"></a>00133             *<span class="keyword">this</span> = r;
<a name="l00134"></a>00134         }
<a name="l00135"></a>00135 
<a name="l00137"></a><a class="code" href="classOgre_1_1GLTexturePtr.html#a7db02931722893f4bd1f88a85085a3cf">00137</a>         <a class="code" href="classOgre_1_1GLTexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GLTexturePtr.">GLTexturePtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1SharedPtr.html">ResourcePtr</a>&amp; r)
<a name="l00138"></a>00138         {
<a name="l00139"></a>00139             <span class="keywordflow">if</span> (pRep == static_cast&lt;GLTexture*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00140"></a>00140                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00141"></a>00141             release();
<a name="l00142"></a>00142             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00143"></a>00143             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00144"></a>00144             {
<a name="l00145"></a>00145                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00146"></a>00146                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00147"></a>00147                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00148"></a>00148                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00149"></a>00149                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00150"></a>00150                 {
<a name="l00151"></a>00151                     ++(*pUseCount);
<a name="l00152"></a>00152                 }
<a name="l00153"></a>00153             }
<a name="l00154"></a>00154             <span class="keywordflow">else</span>
<a name="l00155"></a>00155             {
<a name="l00156"></a>00156                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00157"></a>00157                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">&quot;RHS must be null if it has no mutex!&quot;</span>);
<a name="l00158"></a>00158                 setNull();
<a name="l00159"></a>00159             }
<a name="l00160"></a>00160             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00161"></a>00161         }
<a name="l00163"></a><a class="code" href="classOgre_1_1GLTexturePtr.html#ab13441547d03a0c258bc4fd5c048c0cf">00163</a>         <a class="code" href="classOgre_1_1GLTexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to GLTexturePtr.">GLTexturePtr</a>&amp; operator=(<span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; r)
<a name="l00164"></a>00164         {
<a name="l00165"></a>00165             <span class="keywordflow">if</span> (pRep == static_cast&lt;GLTexture*&gt;(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>()))
<a name="l00166"></a>00166                 <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00167"></a>00167             release();
<a name="l00168"></a>00168             <span class="comment">// lock &amp; copy other mutex pointer</span>
<a name="l00169"></a>00169             <a class="code" href="OgrePrerequisites_8h.html#a2201eef4cf31a94b24d79de6de3445af">OGRE_MUTEX_CONDITIONAL</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00170"></a>00170             {
<a name="l00171"></a>00171                 <a class="code" href="OgrePrerequisites_8h.html#a8a4683cdaf73994ea7ec391c1ba82b60">OGRE_LOCK_MUTEX</a>(*r.OGRE_AUTO_MUTEX_NAME)
<a name="l00172"></a>00172                 <a class="code" href="OgrePrerequisites_8h.html#acf02af48b9d015cd2f0c10e22466c73a">OGRE_COPY_AUTO_SHARED_MUTEX</a>(r.OGRE_AUTO_MUTEX_NAME)
<a name="l00173"></a>00173                 pRep = <span class="keyword">static_cast&lt;</span><a class="code" href="classOgre_1_1GLTexture.html">GLTexture</a>*<span class="keyword">&gt;</span>(r.<a class="code" href="classOgre_1_1SharedPtr.html#a15e055008751a7c20bdde38662d5f0a1">getPointer</a>());
<a name="l00174"></a>00174                 pUseCount = r.<a class="code" href="classOgre_1_1SharedPtr.html#a21c3410c03ec3a4647c7aaa8e59d535d">useCountPointer</a>();
<a name="l00175"></a>00175                 <span class="keywordflow">if</span> (pUseCount)
<a name="l00176"></a>00176                 {
<a name="l00177"></a>00177                     ++(*pUseCount);
<a name="l00178"></a>00178                 }
<a name="l00179"></a>00179             }
<a name="l00180"></a>00180             <span class="keywordflow">else</span>
<a name="l00181"></a>00181             {
<a name="l00182"></a>00182                 <span class="comment">// RHS must be a null pointer</span>
<a name="l00183"></a>00183                 assert(r.<a class="code" href="classOgre_1_1SharedPtr.html#a8a223db784efd7aa766792649de2f2a0">isNull</a>() &amp;&amp; <span class="stringliteral">&quot;RHS must be null if it has no mutex!&quot;</span>);
<a name="l00184"></a>00184                 setNull();
<a name="l00185"></a>00185             }
<a name="l00186"></a>00186             <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00187"></a>00187         }
<a name="l00188"></a>00188     };
<a name="l00189"></a>00189 }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 <span class="preprocessor">#endif // __GLTEXTURE_H__</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
